%global momorel 3
%global kdever 4.1.0
%global kdelibsrel 1m
%global qtver 4.4.0
%global qtrel 1m
%global cmakever 2.4.8
%global cmakerel 5m
%global ftpdirver 4.1.0
%global sourcedir stable/%{ftpdirver}/src

%global python_ver %(%{__python} -c "import sys ; print sys.version[:3]")
%global python_sitelib  %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")
%global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")
%global ruby_ver 1.8
%global ruby_sitelib %{_prefix}/lib/ruby/site_ruby/%{ruby_ver}
%global ruby_sitearch %{_libdir}/ruby/site_ruby/%{ruby_ver}/%{_arch}-linux

# define to enable these optional bits
#global csharp 1
%global ruby 1
%global smoke 1
#global php 1

%if 0%{?ruby}%{?smoke}
%global devel 1
%endif

Summary: KDE bindings to non-C++ languages
Name: kdebindings
Version: %{kdever}
Release: %{momorel}m%{?dist}
Group: User Interface/Desktops
License: GPLv2
URL: http://developer.kde.org/language-bindings/
Source0: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{version}.tar.bz2
NoSource: 0
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  kdelibs-devel >= %{version}
BuildRequires:  kdebase-workspace-devel >= %{version}
BuildRequires:  kdegraphics-devel >= %{version}
BuildRequires:  soprano-devel >= 2.0.97
BuildRequires:  cmake >= %{cmakever}-%{cmakerel}
BuildRequires:  giflib-devel
# FIMXE:TODO: disabled for now
%{?csharp:BuildRequires:  mono-core}
BuildRequires:  pcre-devel
BuildRequires:  PyQt4-devel >= 4.3.3-4m
%{?ruby:BuildRequires:  ruby-devel ruby}
BuildRequires:  qscintilla-devel >= 2.1
# causes smokeqt to fail to build
# BuildRequires:  qwt-devel
BuildRequires:  ruby-devel >= 1.8.7
# remove to enable build kdebindings
BuildConflicts: dbus-qt3-devel

Obsoletes: qtruby

# FIXME/TODO: are there other explicit Requires?
Requires(post): /sbin/ldconfig 
Requires(postun): /sbin/ldconfig 
Requires: kdelibs >= %{version}
Requires: kdebase-workspace >= %{version}

%description
KDE bindings to non-C++ languages

%package -n PyKDE4 
Summary:  Python bindings for KDE4
Group:    Development/Languages
Requires: kdelibs >= %{version}
Requires: PyQt4

%description -n PyKDE4 
Header files for developing applications using %{name}.

%package -n PyKDE4-devel
Summary:  Files needed to build other bindings based on KDE4
Group:    Development/Languages
Requires: PyQt4-devel
Requires: PyKDE4 = %{version}-%{release}

%description -n PyKDE4-devel 
Files needed to build other bindings for C++ classes that inherit from any
of the KDE4 classes.

%package devel
Summary:  Header files for %{name}
Group:    Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: kdelibs-devel kdebase-workspace-devel
Requires: PyQt4-devel
Provides: PyKDE4-devel = %{version}-%{release}

%description devel
Header files for developing applications using %{name}.

%prep
%setup -q

%build
mkdir -p %{_target_platform}
pushd %{_target_platform}
# FIXME/TODO: Get csharp to compile
%{cmake_kde4} \
	%{!?csharp:-DBUILD_csharp=OFF} \
	%{!?php:-DBUILD_php=OFF} \
	%{!?ruby:-DBUILD_ruby=OFF} \
	%{?ruby:-DRUBY_SITE_LIB_DIR=%{ruby_sitelib} -DRUBY_SITE_ARCH_DIR=%{ruby_sitearch}} \
	%{!?smoke:-DBUILD_smoke=OFF} \
	..
popd

# smp build not recommended (upstream)
make -C %{_target_platform}

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

mkdir %{buildroot}
make install DESTDIR=%{buildroot} -C %{_target_platform}

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
/sbin/ldconfig ||:

%postun
/sbin/ldconfig ||:

%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING COPYING.LIB NEWS README
%if 0%{?smoke}
%{_kde4_libdir}/lib*.so.*
%endif
# unversioned library
%{_kde4_libdir}/kde4/krosspython.so
%if 0%{?ruby}
%{_kde4_bindir}/*
%{_kde4_libdir}/libqtruby4shared.so
%{_kde4_libdir}/kde4/krossruby.so
%{_kde4_libdir}/kde4/krubypluginfactory.so
%{ruby_sitelib}/KDE
%{ruby_sitelib}/Qt
%{ruby_sitelib}/khtml
%{ruby_sitelib}/ktexteditor
%{ruby_sitelib}/nepomuk
%{ruby_sitelib}/phonon
%{ruby_sitelib}/qtscript
%{ruby_sitelib}/qtuitools
%{ruby_sitelib}/qtwebkit
%{ruby_sitelib}/solid
%{ruby_sitelib}/soprano
%{ruby_sitelib}/Qt.rb
%{ruby_sitelib}/Qt3.rb
%{ruby_sitelib}/Qt4.rb
%{ruby_sitearch}/*.so
%{_kde4_datadir}/applications/kde4/dbpedia_references.desktop
%{_kde4_appsdir}/dbpedia_references
%endif

%files -n PyKDE4
%defattr(-,root,root,-)
%doc COPYING
%{python_sitearch}/PyKDE4/
%{_kde4_appsdir}/pykde4/

%files -n PyKDE4-devel
%defattr(-,root,root,-)
%doc %{_kde4_docdir}/HTML/en/pykde4/
%{_kde4_datadir}/sip/PyKDE4/

%if 0%{?devel}
%files devel
%defattr(-,root,root,-)
%if 0%{?smoke}
%{_kde4_includedir}/smoke.h
%{_kde4_includedir}/smoke
%{_kde4_libdir}/libsmoke*.so
%endif
%if 0%{?ruby}
%{_kde4_includedir}/qtruby
%exclude %{_kde4_libdir}/libqtruby4shared.so
%endif
%endif

%changelog
* Wed Jul 30 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.0-3m)
- revise %%files section

* Wed Jul 30 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.1.0-2m)
- remove merged kate.patch
- modify %%files for official release

* Wed Jul 30 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.0-1m)
- update to KDE 4.1.0

* Sat Jul 19 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.99-1m)
- update to 4.0.99

* Fri Jul 18 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.0.98-3m)
- fix %%files to avoid conflicting

* Fri Jul 18 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.0.98-2m)
- fix Requires of PyKDE4

* Thu Jul 17 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.98-1m)
- update to KDE 4.1 RC 1

* Sat Jul  5 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.85-1m)
- update to 4.0.85

* Mon Jun 30 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.0.84-2m)
- apply rev824845.patch again (to enable build)

* Sun Jun 29 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.84-1m)
- minor version up for KDE 4.1 beta 2

* Fri Jun 27 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.0.83-2m)
- fix build on x86_64

* Fri Jun 27 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.0.83-1m)
- update to KDE 4.1 beta 2
- import ruby-cmakelists.patch from Fedora
 +* Fri Jun 20 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.83-3
 +- fix CMake target name conflict between Ruby and Python bindings
- update fix-ruby187.patch

* Thu Jun 26 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.0.80-3m)
- support ruby-1.8.7

* Wed Jun  4 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.0.80-2m)
- enable build on trunk
- sort BR and %%files
- clean up spec file

* Fri May 30 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.80-1m)
- update to KDE 4.1 beta 1

* Sun May 11 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.4-1m)
- update to 4.0.4

* Mon Apr  7 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.3-1m)
- update to 4.0.3

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.0.2-2m)
- rebuild against gcc43

* Sat Mar  8 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.2-1m)
- update to 4.0.2
- delete patches
- disable some features at this time...

* Sat Feb  9 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.1-1m)
- update to 4.0.1

* Wed Feb  6 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.0.0-2m)
- build with qscintilla-2.1

* Sat Jan 12 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (4.0.0-1m)
- update to KDE4

* Wed Oct 17 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (3.5.8-1m)
- update to KDE 3.5.8
- PyQt-3.14.1-13m
- sip-4.2.1-13m
- qtruby-1.0.13-5m
- delete unused patches

* Mon Jun 18 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (3.5.7-2m)
- rebuild against ruby-1.8.6-4m

* Sat May 26 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (3.5.7-1m)
- update to KDE 3.5.7
- PyQt-3.14.1-12m
- sip-4.2.1-12m
- qtruby-1.0.13-4m

* Mon Feb 12 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (3.5.6-2m)
- rebuild against kdelibs etc.

* Sun Jan 28 2007 NARITA Koichi <pulsar@momonga-linunx.org>
- (3.5.6-1m)
- update to KDE 3.5.6
- delete patch 11 (kdebindings-3.5.5-type.patch)

* Wed Dec 27 2006 Masanobu Sato <satoshiga@momonga-linux.org>
- (3.5.5-5m)
- add pyssizet patch from FC

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (3.5.5-4m)
- rebuild against python-2.5

* Wed Nov 08 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.5.5-3m)
- separated sip, PyQt, PyKDE to other packages since bundled ones has not been updated for a long time.
- fix qtrubyver and qtrubyrel since qtruby has been updated to 1.0.13 since KDE-3.5.5

* Tue Oct 31 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (3.5.5-2m)
- rebuild against expat-2.0.0-2m
- PyQt-3.14.1-11m
- sip-4.2.1-11m
- qtruby-1.0.10-16m

* Fri Oct 27 2006 NARITA Koichi <pulsar@momonga-linux.org>
- (3.5.5-1m)
- update to KDE 3.5.5
- PyQt-3.14.1-10m
- sip-4.2.1-10m
- qtruby-1.0.10-15m

* Wed Aug  2 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.5.4-1m)
- update to KDE 3.5.4
- PyQt-3.14.1-9m
- sip-4.2.1-9m
- qtruby-1.0.10-14m

* Wed May 31 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.5.3-1m)
- update to KDE 3.5.3
- PyQt-3.14.1-8m
- sip-4.2.1-8m
- qtruby-1.0.10-13m

* Wed Mar 29 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.5.2-1m)
- update to KDE 3.5.2
- update python.patch
- PyQt-3.14.1-7m
- sip-4.2.1-7m
- qtruby-1.0.10-12m

* Tue Feb 7 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (3.5.1-2m)
- build against perl-5.8.8 (mjsk (^^;;;
- PyQt-3.14.1-6m
- sip-4.2.1-6m
- qtruby-1.0.10-11m

* Wed Feb  1 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.5.1-1m)
- update to KDE 3.5.1
- PyQt-3.14.1-5m
- sip-4.2.1-5m
- qtruby-1.0.10-10m

* Sat Jan 28 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.5.0-2m)
- add --enable-new-ldflags to configure
- disable_gcc_check_and_hidden_visibility 1
- remove BuildConflicts: mono
- PyQt-3.14.1-4m
- sip-4.2.1-4m
- qtruby-1.0.10-9m

* Wed Nov 30 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.5.0-1m)
- update to KDE 3.5
- PyQt-3.14.1-3m
- sip-4.2.1-3m
- qtruby-1.0.10-8m

* Wed Nov 16 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.5.0-0.1.2m)
- use make, "make -j2" doesn't work
- disable hidden visibility
- PyQt-3.14.1-2m
- sip-4.2.1-2m
- qtruby-1.0.10-7m

* Sat Nov 12 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.5.0-0.1.1m)
- update to KDE 3.5 RC1
- PyQt-3.14.1-1m
- sip-4.2.1-1m
- qtruby-1.0.10-6m

* Sat Oct 29 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.3-2m)
- rebuild against python-2.4.2
- PyQt-3.13-7m
- sip-4.1.1-7m
- qtruby-1.0.10-5m

* Thu Oct 13 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.3-1m)
- update to KDE 3.4.3
- PyQt-3.13-6m
- sip-4.1.1-6m
- qtruby-1.0.10-4m

* Mon Sep 19 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.2-3m)
- rebuild against qscintilla-1.6-1m
- PyQt-3.13-5m
- sip-4.1.1-5m
- qtruby-1.0.10-3m

* Wed Sep 14 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.2-2m)
- add --disable-rpath to configure
- PyQt-3.13-4m
- sip-4.1.1-4m
- qtruby-1.0.10-2m

* Thu Jul 28 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.2-1m)
- update to KDE 3.4.2
- PyQt-3.13-3m
- sip-4.1.1-3m
- qtruby-1.0.10-1m
- add %%doc

* Mon Jun 13 2005 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (3.4.1-2m)
- rebuilt against perl-5.8.7

* Wed Jun  1 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.1-1m)
- update to KDE 3.4.1
- --disable-final

* Mon Mar 28 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.0-1m)
- update to KDE 3.4.0
- update python(version).patch
- import kdebindings-3.3.92-xdg.patch from Fedora Core
- add kdebindings-3.4.0-rbkconfig_compiler-Makefile.patch

* Sun Mar 20 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (3.3.2-4m)
- rebuild against qscintilla-1.5.1

* Tue Feb  8 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (3.3.2-3m)
- $(prefix)/lib -> $(libdir)

* Tue Feb  8 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (3.3.2-2m)
- enable x86_64.

* Mon Dec 13 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.3.2-1m)
- update to KDE 3.3.2
 
* Mon Oct 18 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.3.1-1m)
- update to KDE 3.3.1
- versions of sip, PyQt and qtruby are 4.0.2-4m, 3.12-4m, 1.0.3-1m respectively
 
* Mon Sep 27 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (3.3.0-3m)
- rebuild against kdelibs-3.3.0-3m (libstdc++-3.4.1)

* Sun Sep 26 2004 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.3.0-2m)
- revise %%files section
  %%{_libdir}/*.so* -> %%{_libdir}/*.so.*

* Fri Sep 24 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.3.0-1m)
- KDE 3.3.0
- make sip, PyQt, qtruby subpackages
- add Patch100

* Thu Jun 17 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.2.3-1m)
- KDE 3.2.3
- Bugfix Release
 
* Sat Apr 24 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.2.3-1m)
- KDE 3.2.3

* Tue Mar 23 2004 Toru Hoshina <t@momonga-linux.org>
- (3.2.1-2m)
- revised spec for enabling rpm 4.2.

* Sat Mar 13 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.2.1-1m)
- KDE 3.2.1 Release

* Sat Feb 14 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.2.0-1m)
- KDE 3.2.0
- modified %%files

* Thu Jan 15 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (3.1.5-1m)
- update to 3.1.5

* Fri Dec 26 2003 kourin <kourin@fh.freeserve.ne.jp>
- (3.1.4-4m)
- rebuild against for qt-3.2.3

* Mon Nov 10 2003 kourin <kourin@fh.freeserve.ne.jp>
- (3.1.4-3m)
- rebuild against for qt-3.2.3

* Fri Oct 3 2003 kourin <kourin@fh.freeserve.ne.jp>
- (3.1.4-2m)
- change includedir

* Wed Sep 24 2003 kourin <kourin@fh.freeserve.ne.jp>
- (3.1.4-1m)
- update to 3.1.4

* Wed Aug 13 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.1.3-1m)
- update to 3.1.3

* Mon May 26 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.1.2-1m)
- update to 3.1.2
- delete export _POSIX2_VERSION=199209 and add BuildPreReq: coreutils >= 5.0-1m (for glibc-2.3.2 environment)

* Mon May 12 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.1.1-3m)
- export _POSIX2_VERSION=199209

* Sun Mar 23 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (3.1.1-2m)
- rebuild against for XFree86-4.3.0

* Fri Mar 21 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.1.1-1m)
- update to 3.1.1
  Changelog from 3.0.5 to 3.1
    bindings updated.
  Changelog from 3.1 to 3.1.1
    Removing Qt bindings for private interfaces that were accidentally included and now caused compilation failures with Qt 3.1.2.
    Several other build related fixes.
 
* Thu Mar  6 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (3.0.5a-2m)
- remove kmozilla

* Sun Jan 12 2003 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.5a-1m)
- ver up.

* Wed Dec 11 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.0.4-2m)
- use autoconf-2.53

* Fri Oct 11 2002 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.4-1m)
- ver up.

* Mon Aug 19 2002 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.3-1m)
- ver up.

* Wed Jul 17 2002 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.2-2m)
- rebuild against qt-3.0.5.

* Sun Jul 14 2002 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.2-1m)
- ver up.

* Sun Jun  9 2002 Tadataka Yoshikawa <yosshy@kondara.org>
- (3.0.1-2k)
- ver up.

* Thu Apr  4 2002 Toru Hoshina <t@kondara.org>
- (3.0.0-2k)
  update to 3.0 release.

* Sat Feb 23 2002 Shigeru Yamazaki <s@kondara.org>
- (2.2.2-4k)
- rebuild against python 2.2 and mozilla 0.9.8

* Tue Nov 27 2001 Toru Hoshina <t@kondara.org>
- (2.2.2-2k)
- version up.

* Fri Nov  2 2001 Toru Hoshina <t@kondara.org>
- (2.2.1-8k)
- rebuild against mozilla 0.9.5.

* Tue Oct 30 2001 Toru Hoshina <t@kondara.org>
- (2.2.1-6k)
- revised spec file.

* Tue Oct 16 2001 Toru Hoshina <t@kondara.org>
- (2.2.1-4k)
- rebuild against libpng 1.2.0.

* Thu Oct  4 2001 Toru Hoshina <t@kondara.org>
- (2.2.1-2k)
- version up.

* Wed Aug 22 2001 Toru Hoshina <toru@df-usa.com>
- (2.2.0-2k)
- stable release, however still no fam, no python2...

* Sat Aug 11 2001 Toru Hoshina <toru@df-usa.com>
- (2.2.0-0.0003002k)
- based on 2.2beta1.

* Fri Jun  1 2001 Toru Hoshina <toru@df-usa.com>
- (2.2.0-0.0002002k)
- based on 2.2alpha2.

* Sat May 12 2001 Toru Hoshina <toru@df-usa.com>
- (2.2.0-0.0001002k)

* Wed Mar 21 2001 Toru Hoshina <toru@df-usa.com>
- (2.1-2k)

* Wed Feb 28 2001 Trond Eivind Glomsr��?<teg@redhat.com>
- rebuild

* Wed Feb 21 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.1

* Sun Jan 28 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- initial RPM
